package com.bergerkiller.bukkit.common.utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.server.CraftingRecipe;
import net.minecraft.server.FurnaceRecipes;
import net.minecraft.server.CraftingManager;
import net.minecraft.server.ShapedRecipes;
import net.minecraft.server.ShapelessRecipes;

import org.bukkit.Material;
import org.bukkit.craftbukkit.inventory.CraftItemStack;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class RecipeUtil {
	private static final Map<Integer, Integer> fuelTimes = new HashMap<Integer, Integer>();
	static {
		fuelTimes.put(Material.WOOD.getId(), 300);
		fuelTimes.put(Material.STICK.getId(), 100);
		fuelTimes.put(Material.COAL.getId(), 1600);
		fuelTimes.put(Material.LAVA_BUCKET.getId(), 20000);
		fuelTimes.put(Material.SAPLING.getId(), 100);
		fuelTimes.put(Material.BLAZE_ROD.getId(), 2400);
	}
	public static Map<Integer, Integer> getFuelTimes() {
		return fuelTimes;
	}
	public static int getFuelTime(int itemid) {
		Integer rval = fuelTimes.get(itemid);
		return rval == null ? 0 : rval;
	}
	public static int getFuelTime(ItemStack item) {
		if (item == null) return 0;
		return getFuelTime(item.getTypeId()) * item.getAmount();
	}
	public static int getFuelTime(net.minecraft.server.ItemStack item) {
		if (item == null) return 0;
		return getFuelTime(item.id) * item.count;
	}
	public static int getFuelTime(Material material) {
		return getFuelTime(material.getId());
	}
	public static boolean isFuelItem(int itemid) {
		return fuelTimes.containsKey(itemid);
	}
	public static boolean isFuelItem(Material material) {
		return isFuelItem(material.getId());
	}
	
	public static ItemStack getFurnaceResult(ItemStack cooked) {
		return new CraftItemStack(getFurnaceResult(cooked.getTypeId()));
	}
	public static net.minecraft.server.ItemStack getFurnaceResult(net.minecraft.server.ItemStack cooked) {
		return getFurnaceResult(cooked.id);
	}
	public static net.minecraft.server.ItemStack getFurnaceResult(int itemid) {
		return FurnaceRecipes.getInstance().a(itemid);
	}
	
	
	public static ItemStack craftItem(int itemid, Integer data, Inventory source) {
		for (CraftingRecipe rec : getCraftRecipes()) {
			net.minecraft.server.ItemStack item = rec.b();
			if (item.id == itemid && (data == null || data == item.getData())) {
				if (rec instanceof ShapedRecipes) {
					//ShapedRecipes recipe = (ShapedRecipes) rec;
					
					
					
					
				} else if (rec instanceof ShapelessRecipes) {
					//ShapelessRecipes recipe = (ShapelessRecipes) rec;
					
					
				}
			}
		}
		return null;
	}
		
	@SuppressWarnings("unchecked")
	public static List<CraftingRecipe> getCraftRecipes() {
		return (List<CraftingRecipe>) CraftingManager.getInstance().b();
	}
}
